﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=RotateBitmapTest.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private xbmpLuckyWheel As B4XBitmap
	Private ivLuckyWheel As B4XView
End Sub

Public Sub Initialize
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	Root.Color = xui.Color_Blue
	
	xbmpLuckyWheel = FillImageToView(xui.LoadBitmap(File.DirAssets, "Lucky wheel.png"), ivLuckyWheel)
	ivLuckyWheel.SetBitmap(xbmpLuckyWheel)
	
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	Dim Degrees As Float = Rnd(0, 361)
'	ivLuckyWheel.SetBitmap(RotateBitmap(xbmpLuckyWheel, Degrees))

	Dim bmp As B4XBitmap = ivLuckyWheel.GetBitmap
	bmp = bmp.Rotate(Degrees)
	ivLuckyWheel.SetBitmap(bmp)
End Sub


Public Sub RotateBitmap (bmp As B4XBitmap, Degrees As Float) As B4XBitmap
	Dim cvs As B4XCanvas
	Dim panel As B4XView = xui.CreatePanel("")
	panel.SetLayoutAnimated(0, 0, 0, bmp.Width, bmp.Height)
	cvs.Initialize(panel)
	cvs.DrawBitmapRotated(bmp, cvs.TargetRect, Degrees)
	cvs.Invalidate
	Dim b As B4XBitmap = cvs.CreateBitmap
	cvs.Invalidate
	cvs.Release
	Return b
End Sub

Public Sub FillImageToView(bmp As B4XBitmap, ImageView As B4XView) As B4XBitmap
	Dim bmpRatio As Float = bmp.Width / bmp.Height
	Dim viewRatio As Float = ImageView.Width / ImageView.Height
	If viewRatio > bmpRatio Then
		Dim NewHeight As Int = bmp.Width / viewRatio
		bmp = bmp.Crop(0, bmp.Height / 2 - NewHeight / 2, bmp.Width, NewHeight)
	Else if viewRatio < bmpRatio Then
		Dim NewWidth As Int = bmp.Height * viewRatio
		bmp = bmp.Crop(bmp.Width / 2 - NewWidth / 2, 0, NewWidth, bmp.Height)
	End If
	Dim scale As Float = 1
    #if B4i
    scale = GetDeviceLayoutValues.NonnormalizedScale
    #End If
	Return bmp.Resize(ImageView.Width * scale, ImageView.Height * scale, True)
End Sub
